Need a special offer?Find out if your project fits.
+
  1. API reference
  • Introduction
  • Connecting to Data Source
  • Browser compatibility
  • Documentation for older versions
  • All documentation

    Using methods and events

    This guide explains how to use Flexmonster methods and events. First, we will get a reference to the Flexmonster instance. Then we will use this reference to call methods and subscribe to events.

    Prerequisites

    • An application with Flexmonster embedded into it.
      If Flexmonster is not yet embedded, see Integrating Flexmonster.

    Get a reference to the Flexmonster instance

    To interact with Flexmonster via its API, you need a reference to the Flexmonster instance. Get the reference during or after the initialization:

    During the initialization

    When calling the new Flexmonster() constructor, assign its result to a variable:

    const pivot = new Flexmonster({
      // …
    });

    After the initialization

    Get the reference to the Flexmonster instance via the uielement property of the component’s container:

    const pivot =
      document.getElementById("flexmonsterContainer").uielement.flexmonster;

    Now the pivot variable contains a reference to the Flexmonster instance. Use the pivot to access Flexmonster API.

    Use methods

    Call Flexmonster methods using the reference to the Flexmonster instance:

    pivot.setReport(report);

    Some methods can also be defined as Flexmonster initialization parameters:

    const pivot = new Flexmonster({
      // …
      customizeCell: customizeCellFunction
    });

    Such methods include:

    See the full list of Flexmonster methods.

    Use events

    There are two ways to subscribe to an event:

    You can also unsubscribe from an event.

    Subscribing to an event via the initialization parameters

    Define an event as the new Flexmonster() parameter and assign an event handler to it:

    const pivot = new Flexmonster({
      // …
      reportcomplete: onReportComplete
    });

    See the full list of Flexmonster events.

    Subscribing to an event via the on() method

    Call the on() method using the reference to the Flexmonster instance:

    pivot.on('reportcomplete', onReportComplete);

    Check out the full list of Flexmonster events.

    Unsubscribing from an event

    Use the off() method to unsubscribe from an event:

    pivot.off('reportcomplete');

    This will remove all handlers from the event. To remove a specific handler, pass its name as a second parameter to off():

    pivot.off('reportcomplete', onReportComplete);

    Note If a handler is specified as an anonymous function, you can remove it only by removing all handlers.

    See also

All documentation
  • Using methods and events

    This guide explains how to use Flexmonster methods and events in a Svelte application. First, we will get a reference to the Flexmonster instance. Then we will use this reference to call methods and subscribe to events.

    Prerequisites

    • A Svelte application with Flexmonster embedded into it.
      If Flexmonster is not yet embedded, see Integration with Svelte.

    Get a reference to the Flexmonster instance

    To interact with Flexmonster through code, you need a reference to the <Flexmonster> component instance.

    Declare a reference using Svelte’s bind:property directive:

    <script lang="ts">
    import { Flexmonster } from "svelte-flexmonster";
    let pivot: Flexmonster.Pivot;
    </script>

    <div>
    <Flexmonster
    bind:pivot
    toolbar
    />
    </div>

    The pivot variable now holds a reference to the Flexmonster component instance.

    Use methods

    Call Flexmonster’s methods on the variable with the Flexmonster instance (e.g., pivot):

    pivot.showCharts("pie");

    Some methods can also be defined as <Flexmonster> props:

    <Flexmonster
    bind:pivot
    toolbar={true}
    customizeCell={customizeCellFunction}
    />

    Such methods include:

    Find more examples of using Flexmonster’s methods in our sample Svelte project.

    Check out the full list of Flexmonster’s methods.

    Use events

    There are two ways to subscribe to Flexmonster events:

    You can also unsubscribe from an event.

    Subscribing to an event via the component's props

    Define an event as the component's prop and assign an event handler to it:

    <Flexmonster
      bind:pivot
      toolbar={true}
      beforetoolbarcreated={customizeToolbar}
    />

    The event handler (in our case, customizeToolbar) should be defined in the <script> section of the file.

    The sample Svelte.js project demonstrates how to subscribe to events via the component’s props.

    See the full list of Flexmonster events.

    Subscribing to an event via the on() method

    Use the previously created pivot variable to call the on() method:

    pivot.on("reportcomplete", onReportComplete);

    See how the on() method is used in the sample Svelte project.

    Check out the full list of Flexmonster events.

    Unsubscribing from an event

    Use the previously created pivot variable to call the off() method and unsubscribe from an event:

    pivot.off(eventName);

    This will remove all handlers from the event. To remove a specific handler, pass its name as a second parameter to off():

    pivot.off("reportcomplete", onReportComplete);

    Note If a handler is specified as an anonymous function, you can remove it only by removing all handlers.

    See how the off() method is used in the sample Svelte project.

    See also

    Frequently asked questions

    Can't find your answer?
    Visit the FAQ

    Flexmonster Pivot Table & Charts is a JavaScript pivot table component for adding interactive reporting and data analysis to web applications. Users can summarize, filter, sort, and explore data in pivot tables and charts, drill into results, and export reports.

Need a special offer?Find out if your project fits.
+
  1. API reference
  • Introduction
  • Connecting to Data Source
  • Browser compatibility
  • Documentation for older versions
  • Table of contents

    Using methods and events

    This guide explains how to use Flexmonster methods and events in an Angular application. First, we will create a reference to the Flexmonster instance. Then we will use this reference to call methods and subscribe to events.

    Prerequisites

    • An Angular application with Flexmonster embedded into it.
      If Flexmonster is not yet embedded, see Integration with Angular.

    Create a reference to the <fm-pivot> instance

    To access Flexmonster API inside the .component.ts file, we need a reference to the <fm-pivot> instance. Follow the steps below to create the reference using the @ViewChild decorator:

    Step 1. In the HTML template of the component with Flexmonster (e.g., src/app/app.component.html), assign a template reference variable to the <fm-pivot> instance (e.g., #pivot):

    <fm-pivot #pivot
     [toolbar]="true">
    </fm-pivot>

    Step 2. In the component’s TypeScript file (e.g., src/app/app.component.ts), import the @ViewChild decorator:

    import { Component, ViewChild } from '@angular/core';

    Step 3. In the same TypeScript file, import FlexmonsterPivot from the Flexmonster wrapper used in your project:

    ngx-flexmonster

    import { FlexmonsterPivot } from 'ngx-flexmonster';

    ng-flexmonster

    import { FlexmonsterPivot } from 'ng-flexmonster';

    Step 4. In the same TypeScript file, use @ViewChild to inject a reference to the <fm-pivot> instance (e.g., pivotRef):

    @ViewChild('pivot') pivotRef!: FlexmonsterPivot;

    pivot is the template reference variable assigned to the <fm-pivot> instance in step 1.

    Depending on the Flexmonster wrapper, the full code from steps 2-4 should look similar to the following:

    ngx-flexmonster

    import { Component, ViewChild } from '@angular/core';
    import { FlexmonsterPivot } from 'ngx-flexmonster';
    
    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css'],
    })
    export class AppComponent {
      @ViewChild('pivot') pivotRef!: FlexmonsterPivot;
      // other code
    }

    ng-flexmonster

    import { Component, ViewChild } from '@angular/core';
    import { FlexmonsterPivot } from 'ng-flexmonster';
    
    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css'],
    })
    export class AppComponent {
      @ViewChild('pivot') pivotRef!: FlexmonsterPivot;
      // other code
    }

    The pivotRef reference to the <fm-pivot> instance is created.

    In this guide, we will use the pivotRef.flexmonster property, which is a reference to the Flexmonster instance. The pivotRef.flexmonster gives you access to Flexmonster API.

    Use methods

    Call Flexmonster methods using the previously created pivotRef reference:

    this.pivotRef.flexmonster.setReport(this.report);

    Some methods can also be defined as <fm-pivot> attributes:

    <fm-pivot #pivot
     [toolbar]="true"
     [customizeCell]="customizeCellFunction">
    </fm-pivot>

    Such methods include:

    Check out the sample Angular project for more examples with Flexmonster methods.

    See the full list of Flexmonster methods.

    Use events

    There are two ways to subscribe to Flexmonster events:

    You can also unsubscribe from an event.

    Subscribing to an event via the <fm-pivot> attributes

    Define an event as the <fm-pivot> attribute in round brackets and assign an event handler to it:

    <fm-pivot #pivot
     [toolbar]="true"
     [report]="'https://cdn.flexmonster.com/reports/report.json'"
     (reportcomplete)="onReportComplete()">
    </fm-pivot>

    The sample Angular project demonstrates how to subscribe to events via the directive’s attributes.

    See the full list of Flexmonster events.

    Learn more about events in Angular.

    Subscribing to an event via the on() method

    Use the previously created pivotRef reference to call the on() method:

    this.pivotRef.flexmonster.on('reportcomplete', onReportComplete);

    See how the on() method is used in the sample Angular project.

    Check out the full list of Flexmonster events.

    Unsubscribing from an event

    Use the off() method to unsubscribe from an event:

    this.pivotRef.flexmonster.off('reportcomplete');

    This will remove all handlers from the event. To remove a specific handler, pass its name as a second parameter to off():

    this.pivotRef.flexmonster.off('reportcomplete', onReportComplete);

    Note If a handler is specified as an anonymous function, you can remove it only by removing all handlers.

    See how the off() method is used in the sample Angular project.

    See also

Need a special offer?Find out if your project fits.
+
  1. API reference
  • Introduction
  • Connecting to Data Source
  • Browser compatibility
  • Documentation for older versions
  • Table of contents

    Using methods and events

    This guide explains how to use Flexmonster methods and events in a React application. First, we will get a reference to the Flexmonster instance. Then we will use this reference to call methods and subscribe to events.

    Prerequisites

    • A React application with Flexmonster embedded into it.
      If Flexmonster is not yet embedded, see Integration with React.

    Get a reference to the Flexmonster instance

    To interact with Flexmonster through code, you need a reference to the FlexmonsterReact.Pivot instance. Follow the steps below to get the reference:

    Step 1. Import the useRef hook from React:

    import { useRef } from "react";

    Step 2. Using the useRef hook, create an empty ref object (e.g., pivotRef):

    ES6

    function App() {
      const pivotRef = useRef(null);
      // ...
    }

    TypeScript

    function App() {
      const pivotRef: React.RefObject<FlexmonsterReact.Pivot> 
        = useRef<FlexmonsterReact.Pivot>(null);
      // ...
    }

    Step 3. Pass the created object (e.g., pivotRef) as the ref attribute to FlexmonsterReact.Pivot:

    ES6

    function App() {
      const pivotRef = useRef(null);
    
      return (
        <div className="App">
          <FlexmonsterReact.Pivot
           ref={pivotRef}
           toolbar={true}
          />
        </div>
      );
    }

    TypeScript

    function App() {
      const pivotRef: React.RefObject<FlexmonsterReact.Pivot> 
        = useRef<FlexmonsterReact.Pivot>(null);
    
      return (
        <div className="App">
          <FlexmonsterReact.Pivot
           ref={pivotRef}
           toolbar={true}
          />
        </div>
      );
    }

    The pivotRef reference to the FlexmonsterReact.Pivot instance is created.

    In this guide, we will use the pivotRef.current.flexmonster property, which is a reference to the Flexmonster instance. The pivotRef.current.flexmonster gives you access to Flexmonster API.

    Use methods

    Call Flexmonster methods using the previously created pivotRef:

    ES6

    pivotRef.current.flexmonster.setReport(report);

    TypeScript

    pivotRef.current?.flexmonster.setReport(report);

    Some methods can also be defined as FlexmonsterReact.Pivot props:

    <FlexmonsterReact.Pivot
     ref={pivotRef}
     toolbar={true}
     customizeCell={customizeCellFunction}
    />

    Such methods include:

    Check out the sample React project for more examples with Flexmonster methods:

    See the full list of Flexmonster methods.

    Use events

    There are two ways to subscribe to Flexmonster events:

    You can also unsubscribe from an event.

    Subscribing to an event via the FlexmonsterReact.Pivot props

    Define an event as the FlexmonsterReact.Pivot prop and assign an event handler to it:

    <FlexmonsterReact.Pivot
     report="https://cdn.flexmonster.com/reports/report.json"
     reportcomplete={onReportComplete}
    />

    Handlers can be passed as inline JavaScript code or as variables. In both cases, curly braces should be used:

    Inline handler

    <FlexmonsterReact.Pivot
      toolbar="true"
      beforetoolbarcreated={toolbar => {
        toolbar.showShareReportTab = true;
      }}
    />

    Handler passed as a variable

    <FlexmonsterReact.Pivot
      toolbar="true"
      beforetoolbarcreated={customizeToolbar}
    />

    The sample React project demonstrates how to subscribe to events via the component’s props:

    See the full list of Flexmonster events.

    Subscribing to an event via the on() method

    Use the previously created pivotRef to call the on() method:

    ES6

    pivotRef.current.flexmonster.on("reportcomplete", onReportComplete);

    TypeScript

    pivotRef.current?.flexmonster.on("reportcomplete", onReportComplete);

    See how the on() method is used in the sample React project:

    Check out the full list of Flexmonster events.

    Unsubscribing from an event

    Use the off() method to unsubscribe from an event:

    ES6

    pivotRef.current.flexmonster.off("reportcomplete");

    TypeScript

    pivotRef.current?.flexmonster.off("reportcomplete");

    This will remove all handlers from the event. To remove a specific handler, pass its name as a second parameter to off():

    ES6

    pivotRef.current.flexmonster.off("reportcomplete", onReportComplete);

    TypeScript

    pivotRef.current?.flexmonster.off("reportcomplete", onReportComplete);

    Note If a handler is specified as an anonymous function, you can remove it only by removing all handlers.

    See how the off() method is used in the sample React project:

    See also

☝️Small business or a startup? See if you qualify for our special offer.
+
All documentation
  • Introduction
  • Connecting to data source
  • Browser compatibility
  • Documentation for older versions
  • Using methods and events

    This guide explains how to use Flexmonster methods and events in a Vue 3 application. First, we will get a reference to the Flexmonster instance. Then we will use this reference to call methods and subscribe to events.

    Prerequisites

    • A Vue 3 application with Flexmonster embedded into it.
      If Flexmonster is not yet embedded, see Integration with Vue 3.

    Get a reference to the Flexmonster instance

    To interact with Flexmonster through code, you need a reference to the <Pivot> instance. Get the reference using the ref attribute:

    <template>
    <Pivot
    ref="pivot"
    toolbar
    />
    </template>

    The pivot ref can be accessed through this.$refs.

    In this guide, we will use the pivot.flexmonster property, which is a reference to the Flexmonster instance. The pivot.flexmonster gives you access to Flexmonster API.

    Use methods

    Call Flexmonster methods using the previously created pivot ref:

    ES6

    this.$refs.pivot.flexmonster.setReport(this.report);

    TypeScript

    ((this.$refs.pivot as typeof Pivot)
    .flexmonster as Flexmonster.Pivot)
    .setReport(this.report);

    Some methods can also be defined as <Pivot> props:

    <Pivot
    ref="pivot"
    toolbar
    v-bind:customizeCell="customizeCellFunction"
    />

    Such methods include:

    Check out the sample Vue 3 project for more examples with Flexmonster methods:

    See the full list of Flexmonster methods.

    Use events

    There are two ways to subscribe to Flexmonster events:

    You can also unsubscribe from an event.

    Subscribing to an event via the <Pivot> props

    Using the v-bind directive, define an event as the <Pivot> prop and assign an event handler to it:

    <Pivot
      report="https://cdn.flexmonster.com/reports/report.json"
      v-bind:reportcomplete="onReportComplete"
    />

    The event handler (in our case, onReportComplete) should be defined in the <script> section of the file.

    The sample Vue 3 project demonstrates how to subscribe to events via the component’s props:

    See the full list of Flexmonster events.

    Subscribing to an event via the on() method

    Use the previously created pivot ref to call the on() method:

    ES6

    this.$refs.pivot.flexmonster.on("reportcomplete", this.onReportComplete);

    TypeScript

    ((this.$refs.pivot as typeof Pivot)
    .flexmonster as Flexmonster.Pivot)
    .on("reportcomplete", this.onReportComplete);

    See how the on() method is used in the sample Vue 3 project:

    Check out the full list of Flexmonster events.

    Unsubscribing from an event

    Use the off() method to unsubscribe from an event:

    ES6

    this.$refs.pivot.flexmonster.off("reportcomplete");

    TypeScript

    ((this.$refs.pivot as typeof Pivot)
    .flexmonster as Flexmonster.Pivot)
    .off("reportcomplete");

    This will remove all handlers from the event. To remove a specific handler, pass its name as a second parameter to off():

    ES6

    this.$refs.pivot.flexmonster.off("reportcomplete", this.onReportComplete);

    TypeScript

    ((this.$refs.pivot as typeof Pivot)
    .flexmonster as Flexmonster.Pivot)
    .off("reportcomplete", this.onReportComplete);

    Note If a handler is specified as an anonymous function, you can remove it only by removing all handlers.

    See how the off() method is used in the sample Vue 3 project:

    See also